<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class ItempindahsubinvModel extends BaseModel
{
	/**
	 * table name from database
	 */
	protected $table = "itempindahbarangsubinv";

	/**
	 *   alias table for relation issues
	 */
	protected $aliasTable = "itempindahsubinv";

	/**
	 * primary key from table remember eloquent doesnt support composite primary key
	 */
	protected $primaryKey = "id";
	/**
	 * check the incrementing boolean if the incrementing from database is false then the value is false by default
	 */
	// public $incrementing = false;
	/**
	 * fillable property for eloquent attribute cast
	 */
	protected $fillable = [
		"id", "itemId", "moNumber", "quantity", "lotNumber", "date_updated", "stokId", "is_sync"
	];
	/**
	 * Creating raw object from table that, this purpose for making you easier for remembering all attribute
	 */


	/**
	 * paging for default paging purpose
	 * if you want to add new paging property you have to add the property in this array
	 * you have to add the relation value
	 * remember this is not suported casting value you have to handle by your self
	 */
	protected $aliasPaging = [
		"id" => "itempindahsubinv.id",
		"itemId" => "itemId.id",
		"namaItem" => "itemId.namaItem",
		"moNumber" => "itempindahsubinv.moNumber",
		"quantity" => "itempindahsubinv.quantity",
		"lotNumber" => "itempindahsubinv.lotNumber",
	];

	/**
	 * relation from ' . item . ' by ' . itemId 
	 * join item on item.id = itempindahsubinv.itemId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationItemId($alias = "itemId")
	{
		$this->getQuery()->join("item as $alias", "$alias.id", "=", "itempindahsubinv.itemId");
		return $this;
	}
	/**
	 * relation from ' . pindahstok . ' by ' . pindahSubinvId 
	 * join pindahstok on pindahstok.id = itempindahsubinv.pindahSubinvId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationPindahSubinvId($alias = "pindahSubinvId")
	{
		$this->getQuery()->join("pindahbarangsubinv as $alias", "$alias.moNumber", "=", "itempindahsubinv.moNumber");
		return $this;
	}

	public function joinRelationStokId($alias = "stokId")
	{
		$this->getQuery()->leftjoin("stokkapal as $alias", "$alias.id", "=", "itempindahsubinv.stokId");
		return $this;
	}

	public function updateTransactionSyncFlag($TRANSACTION_NUM, $ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()->where("itempindahsubinv.moNumber", "=", $TRANSACTION_NUM)
			->where("itempindahsubinv.itemId", "=", $ITEM_ID)
			->where(".lotNumber", "=", $LOT_NUMBER)->first();
		if ($model) {
			$model = self::find($model->id);
			$model->is_sync = 1;
			$model->update();
			// (new LogsynckapalModel)->setLogSync("Update Sync Flag Transfer IO: " . $TRANSACTION_NUM . " - " . $LOT_NUMBER . " - " . $LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
		}
	}

	// RETURN NUMBER OF ROWS AS INTEGER, FOR ITEMS WITH LOT_NUMBER AND IS_SYNC IS NULL
	public function validUpdateStock($ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()
			->selectRaw('COUNT("itempindahsubinv"."itemId") as "nItems"')
			->where("itempindahsubinv.itemId", "=", $ITEM_ID)
			->where("itempindahsubinv.lotNumber", "=", $LOT_NUMBER)
			->whereNull("itempindahsubinv.is_sync")
			->groupBy("itemId")
			->first();
		if ($model) {
			return $model->nItems;
		} else {
			return 0;
		}
	}
}
